<p align="center">
    <img width="120" src="https://apidoc.demo.hg-code.com/images/logo.png">
</p>

<h1 align="center">
  ThinkPHP ApiDoc
</h1>

<div align="center">
 基于 ThinkPHP 的API接口开发工具
</div>

<div align="center" style="margin-top:10px;margin-bottom:50px;">
<a href="https://packagist.org/packages/hg/apidoc"><img src="https://img.shields.io/packagist/v/hg/apidoc"></a>
<a href="https://packagist.org/packages/hg/apidoc"><img src="https://img.shields.io/packagist/dt/hg/apidoc"></a>
<a href="https://packagist.org/packages/hg/apidoc"><img src="https://img.shields.io/packagist/l/hg/apidoc"></a>
<a href="https://github.com/HGthecode/thinkphp-apidoc"><img src="https://img.shields.io/github/issues/HGthecode/thinkphp-apidoc"></a>
<a href="https://github.com/HGthecode/thinkphp-apidoc"><img src="https://img.shields.io/github/forks/HGthecode/thinkphp-apidoc"></a>

</div>


## 🤷‍♀️ Apidoc是什么？

如今，前后端分离的开发模式以必不可少，基于ThinkPHP可以很方便的作为Api接口的开发。可是一个Api开发过程中需要快速调试，开发完成后需要给其它开发者对接等，这时一个功能全面的Api文档工具，就显得特别重要。

大多数开发者可能都是通过各种工具配合来达到这一目的，其各种工具的安装和配置也是繁琐。甚至还有通过word等文本工具手写api文档的，这样的开发效率与可维护性是非常差的。

综合种种Api开发中的痛点，我们专为ThinkPHP开发了Apidoc的扩展，本插件可通过简单的注解即可生成Api文档，及帮助开发者提高生产效率的在线调试、快速生成Crud、一键生成整个模块Api等，涵盖Api开发方方面面。


## ✨特性

- 开箱即用：无繁杂的配置、安装后按文档编写注释即可自动生成API文档。
- 在线调试：在线文档可直接调试，支持全局参数、Mock调试数据、事件执行，接口调试省时省力。
- 轻松使用：支持公共注释定义、业务逻辑层、数据表字段等引用，几句注释即可完成。
- 安全高效：支持访问密码验证、应用/版本独立密码；支持文档缓存。
- 多应用/多版本：可适应各种单应用、多应用、多版本的项目的Api管理。
- Markdown文档：支持.md文件的文档展示。
- 控制器分组：支持控制器多级分组，更精细化管理接口目录。
- 多语言：可结合TP多语言能力，实现接口文档的语言切换。


## 📌兼容

ThinkPHP 5.1

ThinkPHP 6.x

## 📖使用文档

[ThinkPHP ApiDoc V3.x文档](https://hg-code.gitee.io/thinkphp-apidoc/)


## 🏆支持我们

如果本项目对您有所帮助，请点个Star支持我们

- [Github](https://github.com/HGthecode/thinkphp-apidoc) -> <a href="https://github.com/HGthecode/thinkphp-apidoc" target="_blank">
  <img height="22" src="https://img.shields.io/github/stars/HGthecode/thinkphp-apidoc?style=social" class="attachment-full size-full" alt="Star me on GitHub" data-recalc-dims="1" /></a>
- [Gitee](https://gitee.com/hg-code/thinkphp-apidoc) -> <a href="https://gitee.com/hg-code/thinkphp-apidoc/stargazers"><img src="https://gitee.com/hg-code/thinkphp-apidoc/badge/star.svg" alt="star"></a>

## 💡鸣谢

<a href="http://www.thinkphp.cn/" target="_blank">ThinkPHP</a>

<a href="https://github.com/doctrine/annotations" target="_blank">doctrine/annotations</a>


## 🔗链接
 <a href="https://github.com/HGthecode/apidoc-ui" target="_blank">ApiDoc UI</a>
 
 <a href="https://github.com/HGthecode/thinkphp-apidoc-demo" target="_blank">ApiDoc Demo</a>


